
/*
 * $Id: $
 *
 * I n Q u i r a   Copyright (c) 2002 Inquira, Inc. All rights reserved.
 *                 Use or distribution without the express written consent of
 *                 Inquira, Inc. is not permitted and is prohibited by law.
 */
 
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import org.apache.log4j.Logger;
import org.pdfbox.pdfparser.PDFParser;
import org.pdfbox.pdmodel.PDDocument;
import org.pdfbox.util.PDFTextStripper;


/**
 * Extract Text from PDF
 *
 *  
 * Created: Mar 15, 2004 11:08:35 AM
 *
 * @author Brian Guan
 * @version $Revision: $
 */
public class PDF2TXT {
    
    private static Logger log = Logger.getLogger(PDF2TXT.class.getName());

	public static void main(String[] args) {
        
        log.info("Preparing to parse " + args[0]);
        
        File file = new File(args[0]); 

        PDFTextStripper stripper = new PDFTextStripper();
        stripper.setLineSeparator("\n");
        FileInputStream input = null;
        PDFParser parser = null;
        PDDocument document = null;
        OutputStream os = null;
        Writer writer = null;
        try
        {
            input = new FileInputStream(file);
            parser = new PDFParser( input );
            parser.parse();
            document = parser.getPDDocument();

            File outFile = new File(args[0] + ".txt");
            os = new FileOutputStream(outFile);
            writer = new OutputStreamWriter(os, "utf-8");

            stripper.writeText(document, writer);
            log.info("Text for " + file.getName() + ":\r\n" + stripper.getText(document));

        } catch (Exception e) {
            log.error(e);
        } finally {
            if( input != null ) try { input.close(); } catch (Exception e) {}
            if( writer != null ) try { writer.close(); } catch (Exception e) {}
            if( os != null ) try { os.close(); } catch (Exception e) {}
            if( document != null ) try { document.close(); } catch (Exception e) {}
        }
    }
}